"""<one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2013 <name of author> Catrilas, aj_2745, ABT Benjaminsn
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>."""


import pygame, sprites, ai
pygame.init()  
done = False
 
class GameLoop:                                 #Main GameLoop          
        def __init__(self):                     #Initialize the Class
                self.done=False
                self.x= 1
                if self. x == 1:
                        pygame.display.set_caption("Starting Screen")           #Initialize Caption
                        self.clock = pygame.time.Clock()
                        self.screen = pygame.display.set_mode([640, 640])  	#Initializes Screen 
                        self.state = 1
                        self.room = 1
                self.wall_list=pygame.sprite.Group()
                self.mbullets=pygame.sprite.Group()
                self.mobs=pygame.sprite.Group()
                self.pbullets=pygame.sprite.Group()
                self.count=1
                self.gameover=False
                self.font=pygame.font.Font('DroidSansMono.ttf',16)
                self.Main_Loop()
                
                
        def Main_Loop(self):
                while self.done==False:
                        if self.state == 1:
                                self.New_Game()
                        if self.state == 2:
                                self.Teleporter()
                                self.User_Input()
                                self.Move_Sprites()
                                self.Update()
        def Move_Sprites(self):
                for counter in range(1,10):
                        self.pig.update(self.wall_list)
                        self.mobs.update(self.wall_list)
                        self.pbullets.update()
                        self.mbullets.update()
                self.Collision_test()
                        

        def Collision_test(self):
                test=pygame.sprite.spritecollide(self.pig,self.mobs,False,pygame.sprite.collide_mask)
                if test:
                        for dmg in test:
                                if self.pig.invin<1:
                                        self.pig.hp-=dmg.damage
                                        dmg.hp-=self.pig.damage
                                        if dmg.hp<1:
                                                self.mobs.remove(dmg)
                                        self.pig.invin=150
                pygame.sprite.groupcollide(self.pbullets,self.wall_list,True,False,pygame.sprite.collide_mask)
                pygame.sprite.groupcollide(self.mbullets,self.wall_list,True,False,pygame.sprite.collide_mask)
                if pygame.sprite.groupcollide(self.pbullets,self.mobs,False,False,pygame.sprite.collide_mask):
                        remove=()
                        for sprite in self.pbullets.sprites():
                                test=pygame.sprite.spritecollide(sprite,self.mobs,False,pygame.sprite.collide_mask)
                                if test:
                                        remove+=(sprite,)
                                        test[0].hp-=sprite.damage
                                        if test[0].hp<1:
                                                self.mobs.remove(test[0])
                        self.pbullets.remove(remove)
                test=pygame.sprite.spritecollide(self.pig,self.mbullets,False,pygame.sprite.collide_mask)
                if test:
                        for dmg in test:
                                if self.pig.invin<1:
                                        self.pig.hp-=dmg.damage
                                        self.pig.invin=150
                                self.mbullets.remove(dmg)
                test=self.pbullets.sprites()
                for sprite in test:
                        if sprite.rect.top>=650 or sprite.rect.top<=-10:
                                self.pbullets.remove(sprite)
                        if sprite.rect.left>=650 or sprite.rect.left<=-10:
                                self.pbullets.remove(sprite)
                test=self.mbullets.sprites()
                for sprite in test:
                        if sprite.rect.top>=650 or sprite.rect.top<=-10:
                                self.pbullets.remove(sprite)
                        if sprite.rect.left>=650 or sprite.rect.left<=-10:
                                self.pbullets.remove(sprite)
                if self.pig.hp==0:
                        self.state=1
                        self.gameover=True

        def New_Game(self): #Set up initial screen
                if self.gameover:
                        pygame.sprite.Group.empty(self.wall_list)  #Dumps all sprites from groups to create a new screen
                        pygame.sprite.Group.empty(self.mbullets)
                        pygame.sprite.Group.empty(self.mobs) 
                        pygame.sprite.Group.empty(self.pbullets)
                self.map=pygame.image.load('map%d.png'%1).convert_alpha()       
                self.screen.blit(self.map,(0,0))
                self.pig=sprites.Chsprite(300,300,('pig.png','pig2.png'),ai.Pigmove,20,4,self.Attack,ai.Pigattack,1,75,True)
                self.screen.blit(self.pig.image,self.pig.rect)
                self.MobSetup(1)
                self.state = 2
                self.Make_Walls(1)
                #self.Make_Walls(1)
                self.mobs.draw(self.screen)
                if self.gameover:    #gameover screen and restart
                        pygame.display.set_caption("Game Over Thanks for playing")           #Initialize Caption
                else:           #display start screen here
                        pass
                pygame.display.flip()
                self.PressAnyKey()
                self.Main_Loop()
        def PressAnyKey(self):
                start=False
                while start==False:
                        for event in pygame.event.get():
                                if event.type == pygame.QUIT: # If user clicked close
                                        self.done = True # Flag that we are done so we exit this loop
                                        start=True
                                if event.type == pygame.KEYDOWN:
                                        start=True
                                if event.type == pygame.MOUSEBUTTONDOWN:
                                        start=True
                                
        def User_Input(self): #Test for user input
                for event in pygame.event.get(): # User did something
                        if event.type == pygame.QUIT: # If user clicked close
                                self.done = True # Flag that we are done so we exit this loop
                        if event.type == pygame.KEYDOWN:
                                if event.key == pygame.K_c:
                                        print self.pig.rect.center
                                        
        def Update(self):  #Update the screen per frame
                self.screen.blit(self.map,(0,0))
                self.screen.blit(self.pig.image,self.pig.rect)
                self.mobs.draw(self.screen)
                self.pbullets.draw(self.screen)
                self.mbullets.draw(self.screen)
                self.screen.blit(self.font.render('Pig HP = %d'%self.pig.hp,False,(255,0,0)),(0,0))
                pygame.display.flip()
                self.clock.tick(30)
        
        def New_Map(self):  #Switch Between map
                pygame.sprite.Group.empty(self.wall_list)  #Dumps all sprites from groups to create a new screen
                pygame.sprite.Group.empty(self.mbullets)
                pygame.sprite.Group.empty(self.mobs) 
                pygame.sprite.Group.empty(self.pbullets)
                pygame.display.update()
                self.MobSetup(self.room) #Sets up the New mobs for the new room

                self.Make_Walls(1)
                
                pass
        def Attack(self,function,attacker):
                if attacker.pig==True:
                        self.pbullets.add(function(attacker))
                else:
                        self.mbullets.add(function(self.pig,attacker))
        def MobSetup(self,mapnum):
                for m in mobdic[mapnum]:
                        m[6]=self.Attack
                        self.mobs.add(sprites.Chsprite(m[0],m[1],m[2],m[3],m[4],m[5],m[6],m[7],m[8],m[9]))
        def Make_Walls(self,mapnum):
                #map walls, put in where needed later
                #map 1
                wall=pygame.image.load('wall.png').convert_alpha()
                
                if self.room == 1:
                        for x in range(0,609,32):
                                self.wall_list.add(sprites.Wall(x,64))
                                self.wall_list.add(sprites.Wall(x,576))
                                self.wall_list.add(sprites.Wall(544,x))
                        for x in range (13,17):
                                self.wall_list.add(sprites.Wall(x*32,10*32))
                                self.wall_list.add(sprites.Wall(x*32,11*32))
                        self.wall_list.add(sprites.Wall(13*32,9*32))
                        self.wall_list.add(sprites.Wall(14*32,9*32))
                #map 2
                if self.room == 2:
                        for x in range(0,609,32):
                                self.wall_list.add(sprites.Wall(x,64))
                                self.wall_list.add(sprites.Wall(x,608))
                        self.wall_list.add(sprites.Wall(574,608))
                #map 3
                if self.room == 3:
                        for x in range(0,609,32):
                                self.wall_list.add(sprites.Wall(x,64))
                                self.wall_list.add(sprites.Wall(3*32,x))
                                if x>=7*32:
                                        self.wall_list.add(sprites.Wall(x,608))
                #map 4
                if self.room == 4:
                        for x in range(0,609,32):
                                #West Wall
                                self.wall_list.add(sprites.Wall(3*32,x))
                                self.wall_list.add(sprites.Wall(x,544))
                                #Gate moving East
                                if x > 7 * 32:
                                        self.wall_list.add(sprites.Wall(x,96))
                                                
                                self.wall_list.add(sprites.Wall(7*32,0))
                                self.wall_list.add(sprites.Wall(7*32,32))
                                self.wall_list.add(sprites.Wall(7*32,64))

                                #Need to add gate moving south
                                
                #map 5
                if self.room == 5:
                        for x in range(0,609,32):
                                self.wall_list.add(sprites.Wall(x,96))
                                self.wall_list.add(sprites.Wall(x,544))
                if self.room == 6:
                        #map 6
                        for x in range(0,609,32):
                                if x<575:
                                        self.wall_list.add(sprites.Wall(x,96))
                                self.wall_list.add(sprites.Wall(x,17*32))
                                if x>6*32:
                                        self.wall_list.add(sprites.Wall(608,x))
                                if x<97:
                                        self.wall_list.add(sprites.Wall(x,17*32))
                                self.wall_list.add(sprites.Wall(640,x))
                if self.room == 7:
                        #map 7
                        for x in range(0,609,32):
                                self.wall_list.add(sprites.Wall(x,-32))
                                self.wall_list.add(sprites.Wall(-32,x))
                                self.wall_list.add(sprites.Wall(352,x))
                        self.wall_list.add(sprites.Wall(32,640))
                        self.wall_list.add(sprites.Wall(64,640))
                        for x in range(64,630,32):
                                self.wall_list.add(sprites.Wall(x,608))
                                self.wall_list.add(sprites.Wall(320,x))
                        for x in range(0,129,32):
                                self.wall_list.add(sprites.Wall(64,x))
                                self.wall_list.add(sprites.Wall(96,x+160))
                                self.wall_list.add(sprites.Wall(x-32,288))
                                        
        def Teleporter(self):
                #Room 1 left exit
                if self.room == 1:
                        if self.pig.rect.left <= 25 and self.pig.rect.left >= 1 and self.pig.rect.top >= 0 and self.pig.rect.top <= 640:
                                self.pig.rect.x = 590                            
                                self.room = 2
                                self.map=pygame.image.load('map%d.png'%2).convert_alpha()       
                                self.screen.blit(self.map,(0,0))
                                self.New_Map()
                if self.room == 2:
                        #Exit Left
                        if self.pig.rect.left <= 25 and self.pig.rect.left >= 1 and self.pig.rect.top >= 0 and self.pig.rect.top <= 640:
                                self.pig.rect.x = 590                            
                                self.room = 3
                                self.map=pygame.image.load('map%d.png'%3).convert_alpha()       
                                self.screen.blit(self.map,(0,0))
                                self.New_Map()


                if self.room == 3:
                        #Exit Down
                        if self.pig.rect.left >= 0 and self.pig.rect.left <= 640 and self.pig.rect.top >= 590 and self.pig.rect.top <= 640:
                                self.pig.rect.top = 50                            
                                self.room = 4
                                self.map=pygame.image.load('map%d.png'%4).convert_alpha()       
                                self.screen.blit(self.map,(0,0))
                                self.New_Map()


                if self.room == 4:
                        #Exit Right
                        if self.pig.rect.left >= 580 and self.pig.rect.left <= 640 and self.pig.rect.top >= 0 and self.pig.rect.top <= 640:
                                self.pig.rect.left = 50                            
                                self.room = 5
                                self.map=pygame.image.load('map%d.png'%5).convert_alpha()       
                                self.screen.blit(self.map,(0,0))
                                self.New_Map()

                if self.room == 5:
                        #Exit Right
                        if self.pig.rect.left >= 580 and self.pig.rect.left <= 640 and self.pig.rect.top >= 0 and self.pig.rect.top <= 640:
                                self.pig.rect.left = 50                            
                                self.room = 6
                                self.map=pygame.image.load('map%d.png'%6).convert_alpha()       
                                self.screen.blit(self.map,(0,0))
                                self.New_Map()
                if self.room == 6:
                        #Exit Up
                        if self.pig.rect.left >= 0 and self.pig.rect.left <= 640 and self.pig.rect.top >= 0 and self.pig.rect.top <= 50:
                                self.pig.rect.top = 390
                                self.pig.rect.left = 50
                                self.room = 7
                                self.map=pygame.image.load('map%d.png'%7).convert_alpha()       
                                self.screen.blit(self.map,(0,0))
                                self.New_Map()
mobdic={}
mobdic[1]=([150,150,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300],[100,100,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300],
           [100,400,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300],[400,100,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300],
           [150,400,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300],[150,400,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300],
           [350,350,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300],[400,400,'Foreman.png',ai.Mobmoverandom,2,50,None,ai.Mobattack1,1,300])

mobdic[2]=([150,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[150,500,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],
           [350,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[350,500,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],
           [500,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[500,500,'foreman.png',None,2,50,None,ai.Mobattack1,1,300])

mobdic[3]=([192,160,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[224,160,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300])

mobdic[4]=([192,480,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[224,480,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],
           [492,480,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[528,480,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300])

mobdic[5]=([150,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[150,500,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],
           [350,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[350,500,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],
           [500,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[500,500,'foreman.png',None,2,50,None,ai.Mobattack1,1,300])

mobdic[6]=([150,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[150,500,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],
           [350,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[350,500,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],
           [500,150,'Foreman.png',None,2,50,None,ai.Mobattack1,1,300],[500,500,'foreman.png',None,2,50,None,ai.Mobattack1,1,300])

mobdic[7]=([150,250,'Foreman2.png',ai.Mobmoverandom,20,50,None,ai.Mobattack1,1,300],)

game=GameLoop()
     
pygame.quit()   
